eval '(exit $?0)' && eval 'PERLDB_OPTS="N f=26";export PERLDB_OPTS;PERL=`which perl5`; exec $PERL -wS $0 ${1+"$@"}'
    & eval 'setenv PERLDB_OPTS "N f=26"; setenv PERL `which perl5`; exec $PERL -wS $0 $argv:q'
    if 0;

### Local Variables: ***
### mode:perl ***
### comment-column:0 ***
### comment-start: "### " ***
### comment-end: "***" ***
### End: ***
#
# ****************DO NOT MOVE OR CHANGE LINES ABOVE THIS*********************
#
# The first set of lines runs perl from any shell. The second set of lines
# identifies the rest of the file as PERL for EMACS autoformatting.
# See end of copyright for more information.
#
# ----------------------------------------------------------------------------
#                                   X-BONE
#
#                          http://www.isi.edu/xbone
#                USC Information Sciences Institute (USC/ISI)
#                   Marina del Rey, California 90292, USA
#                          Copyright (c) 1998-2004
# ----------------------------------------------------------------------------
#
# Copyright (c) 1998-2004 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation in source and binary forms for non-commercial purposes and
# without fee is hereby granted, provided that the above copyright notice
# appear in all copies and that both the copyright notice and this permission
# notice appear in supporting documentation, and that any documentation,
# advertising materials, and other materials related to such distribution and
# use acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from this
# software without specific prior written permission.
#
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT THE
# SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS PROVIDED "AS
# IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
# LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so noted when
# applicable.
#
# ----------------------------------------------------------------------------
#
# Effort sponsored by the Defense Advanced Research Projects Agency
# (DARPA) and Air Force Research Laboratory, Air Force Materiel
# Command, USAF, under agreement numbers F30602-98-1-0200 and
# F30602-01-2-0529, and by National Science Foundation under agreement
# number ANI-0230789. The U.S. Government is authorized to reproduce
# and distribute reprints for Governmental purposes not withstanding
# any copyright annotation therein.  The views and conclusions
# contained herein are those of the authors and should not be
# interpreted as necessarily representing the official policies or
# endorsements, either expressed or implied, of the Defense Advanced
# Research Projects Agency (DARPA), the Air Force Research Laboratory,
# or the U.S. Government.
#
# ----------------------------------------------------------------------------
#  $RCSfile: xb-gui-config.pl,v $
#
# $Revision: 1.5 $
#   $Author: pingali $
#     $Date: 2004/04/29 00:48:25 $
#    $State: Exp $
# ----------------------------------------------------------------------------
#
############################################################
#
# The first lines start PERL on any system where perl is in the path.
# This is a modified version of the "start perl" script
# provided in the PERL man pages, which starts perl
# on the remainder of the file regardless of whether it
# is run under sh, csh, or perl.
#
# This version is modified to dynamically locate the
# perl path, rather than requiring it be hard-coded.
#
# setenv PERLDB_OPTS "N f=26"
#
# Must be set before perl starts!
#
# N 	: Nonstop (noninteractive)
# f=26	: frame=26 = 16 + 8 + 2,
#		2 = entry and exit,
#		!4 = don't print args to functions
#		8= enabled overloaded stringify and tied FETCH
#		16= print return values from subroutines
#
# note - '-T' (TAINT) switch is not included, because 'which' often
# returns a version of perl that isn't secure. don't worry about it.
#
############################################################
# PERL CODE STARTS HERE
############################################################

# XBONE code to set libraries
BEGIN {
  use strict;
  use sigtrap;
  use FindBin;
  use Config; 
  delete $ENV{PATH};

  # taint-safe backticks equivalent
  my $pid = open KID, "-|";
  unless(defined $pid) { die "open: $!"; }
  unless($pid) {
    foreach my $uname ("/usr/bin/uname", "/bin/uname") {
      if(-x $uname) { exec $uname, "-msr" or die "exec: $!"; }
    }
    die "cannot find uname";
  }
  my ($osname, $osvers, $arch) = split ' ', lc <KID>;
  close KID or die "close: $!";
  $osvers =~ s/^(\d+\.\d+).*/$1/;

  if($osname eq "linux") {
    # same for Linux
    if($arch eq "i686") { $arch =~ s/i\d(\d+)/i3$1/; }
  } elsif($osname eq "freebsd") {
    if($osvers =~ /cairn/) { $osvers = "2.2"; }
  }

  my $ostag = join "-", ($arch, $osname, $osvers);
  print "Configuring perl for $ostag...\n" if 0;

  my $ldir = "/usr/local/xbone";
  my $version = $Config{'version'};
  $arch = $Config{'archname'};

  foreach my $p 
    ( 
     "$ldir/programs/modules", 
     "$ldir/programs/modules/cpan",
     "$ldir/programs/modules/cpan/lib/perl5/$version",
     "$ldir/programs/modules/cpan/lib/perl5/$version/$arch",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/mach",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/mach/$arch",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version/$arch",
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version/mach", 
     "$ldir/programs/modules/cpan/lib/perl5/site_perl/$version/mach/$arch", 
     "$ldir/www", 
     "$ldir/www/cpan",
     "$ldir/www/cpan/lib/perl5/$version",
     "$ldir/www/cpan/lib/perl5/$version/$arch",
     "$ldir/www/cpan/lib/perl5/site_perl/mach",
     "$ldir/www/cpan/lib/perl5/site_perl/mach/$arch",
     "$ldir/www/cpan/lib/perl5/site_perl/$version",
     "$ldir/www/cpan/lib/perl5/site_perl/$version/$arch",
     "$ldir/www/cpan/lib/perl5/site_perl/$version/mach",
     "$ldir/www/cpan/lib/perl5/site_perl/$version/mach/$arch"
    ){
      if(-d $p) { unshift   @INC, $p; }
  }

  # untaint the resulting include path so "use" works
  foreach my $i (@INC) { if($i =~ /(.*)/) { $i = $1;} }

  printf STDERR "\n%s\n\n", join "\n", @INC if 0;
};

##############################################################################
# END OF XBONE PREFIX CODE - PUT YOUR PERL CODE BELOW                        #
##############################################################################

# Primary Author: Gregory G. Finn

use strict;
use sigtrap;

use Data::Dumper;
use Sys::Hostname;
use Term::ReadLine;
use Socket;
use Socket6;
use IO::Socket;
use FileHandle;
use Config;


##########################################
# Global declaration initialization.
##########################################



sub init_nodedb ($) {
  my ($href) = @_;
  my $os = $Config{osname};

}
		
sub get_integer ($$)
{
    my ($prompt, $lref) = @_;
    my ($str, $pat);

    while (1)
    {
	print "$prompt: (range $lref->[0] to $lref->[1]) ";

	$str = <STDIN>;
	chomp $str;

	if ($str !~ /^[0-9]+\Z/)
	{
	   print "\aNot an integer, retry: (range $lref->[0] to $lref->[1]) ";
	   next;
        };

	if ($str < $lref->[0])
	{
	   print "\aToo small, retry: (range $lref->[0] to $lref->[1]) ";
	   next;
        }
	elsif ($str > $lref->[1])
	{
	   print "\n\aToo large, retry: (range $lref->[0] to $lref->[1]) ";
	   next;
        };

	last;
    }

    return ($str);
}

sub get_dotted_decimal ($;$)
{
    my ($prompt, $default) = @_;
    my ($str);

    while (1)
    {
	print "$prompt: [dotted decimal x.x.x.x] ";

	if ($default)
	{ print "($default) "; }

	$str = <STDIN>;
	chomp $str;

	if (!$str)
	{
	    $str = $default;
	    last;
	}
	elsif ($str !~ /^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\Z/)
	{
	   print "\n\aIncorrect dotted decimal address, retry: ";
	   next;
        };

	last;
    }

    return ($str);
}




sub get_string ($;$)
{
    my ($prompt, $default) = @_;
    my ($str, $pat);

GETSTR:
    while (1)
    {
	if (defined ($default))
	{ print "$prompt: ($default) "; }
	else
	{ print "$prompt: "; }

	$str = <STDIN>;
	chomp $str;
	if (!$str) { $str = $default; };

	last;
    }

    return ($str);
}




sub get_oneof ($$)
{
    my ($prompt, $lref) = @_;
    my ($str, $pat);

GETSTR:
    while (1)
    {
	print "$prompt: ($lref->[0]) ";

	$str = <STDIN>;
	chomp $str;
	if (!$str) { $str = $lref->[0];  last GETSTR; };

        foreach $pat (@$lref)
	{ if ($str =~ /$pat/i) { last GETSTR; }; }

	print "\n\aNot acceptable, retry: ($lref->[0]) ";
    }

    return ($str);
}




sub get_someof ($$)
{
    my ($prompt, $lref) = @_;
    my (@str, $str, $match, $pat);

    $match = 0;

SOMEOF:
    while (1)
    {
	print "$prompt: ($lref->[0]) ";

	$_ = <STDIN>;
	chomp $_;
	if (!$_) { @str = ($lref->[0]);  last SOMEOF; };

	@str = split /[, \t\n\r\f]+/;

	foreach $str (@str)
	{
	    $match = 0;

	    foreach $pat (@$lref)
	    { if ($str =~ /$pat/i) { $match = 1;  last; }; }

	    if (!$match)
	    {
		print "Choice of $str is unacceptable, retry: ($lref->[0]) ";
		next SOMEOF;
	    }
	}

	last SOMEOF;
    }

    return "@str";
}




sub fillin_nodedb ($)
{
    my ($href) = @_;
    my @candidates;

    init_nodedb ($href);		# Fill in some global defaults.


    print "\n              Host Information                 ";
    print "\n           ~~~~~~~~~~~~~~~~~~~~~~~           \n";
    $href->{'hostname'} = `hostname`;
    chomp $href->{'hostname'};
    $href->{'hostname'} = 
                 get_string ("Hostname", $href->{'hostname'});

    print "\n           Configuration File Path             ";
    print "\n           ~~~~~~~~~~~~~~~~~~~~~~~           \n";
    $href->{'prefix'} =
      get_string ("Specify directory where configuration files ".
		  "are to be\nstored", $href->{'prefix'});
    if ($href->{'prefix'} ne "/usr/local/etc/xbone"){
      print 
	"\n. Please make sure you edit \n".
        "        /usr/local/www/xbone/lib/XB_Params.pm         \n".
	"with the new location of the configuration file. Look \n".
	"for \$XB_Params::gui_conf. At this point there is no  \n".
	"command line option or other ways of supporting the   \n".
	"modified prefix\n"; 
    }
    
    print "\n             Addresses and Ports           ";
    print "\n             ~~~~~~~~~~~~~~~~~~~           \n";

    @candidates = ("ipv4", "ipv6", "both");
    $href->{'address_type'} =
	get_oneof ("Type of overlays to be supported. Select one of {ipv4, ipv6, both}", \@candidates);
    $href->{'ipproto'} = $href->{'address_type'};

    @candidates = ("yes", "no");
    my $addrsetting =  
      get_oneof ("Would you like to set any ip addresses? " . 
		 "Select one of {yes, no}", \@candidates); 

    if ($addrsetting eq "yes"){
      my ($family, $socktype, $proto, $saddr, $canonname);
      if ($href->{'address_type'} =~ /(ipv4|both)/){
	my @res = getaddrinfo($href->{'hostname'}, 
			       'daytime', # dummy service 
			       AF_INET);
	my $ctl_addr; 
	if (scalar(@res) < 5) {
	  #die ("unknown hostname to compute v4 address $#hostent") 
	  $ctl_addr = "127.0.0.1"; # dont die. just store 
	} else {
	  # the v6 lookup can return multiple ip addresses some of
	  # which may not work. So, try all of them.
	  $family = -1; # for safety 
	  ($family, $socktype, $proto, $saddr, $canonname, @res) 
		             = @res;
	  my ($host, $dummyport) = 
		 getnameinfo($saddr, NI_NUMERICHOST | NI_NUMERICSERV); 

	  $ctl_addr = $host;
      }

	$href->{'ctl_addr'} =
	  get_string ("IPv4 address to be used for Node Daemon communication",
		      $ctl_addr); 
      } # ipv4

      if ($href->{'address_type'} =~ /(ipv6|both)/){
	my @res = getaddrinfo($href->{'hostname'}, 
				'daytime', # dummy service 
				AF_INET6);
	my $ctl_addr6; 
	if (scalar(@res) < 5) {
	  #die ("unknown hostname to compute v4 address $#hostent") 
	  $ctl_addr6 = "::1"; # dont die. just store 
	} else {
	  while(scalar(@res) >= 5) {
	      # the v6 lookup can return multiple ip addresses some of
	      # which may not work. So, try all of them.
	      $family = -1; # for safety 
	      ($family, $socktype, $proto, $saddr, $canonname, @res) 
		         = @res;
	      my ($host, $dummyport) = 
		 getnameinfo($saddr, NI_NUMERICHOST | NI_NUMERICSERV); 

	      if (not defined $ctl_addr6){     
		  $ctl_addr6 = $host; 
	      } else {
		  # this doesnt look right. comparing 2001 with 
		  # binary representation? 
		  if ($host =~ /^2001/){
		      $ctl_addr6 = $host;
		  }
	      }
	  } #while...
        }
	$href->{'ctl_addr6'} =
	  get_string ("Please enter the IPv6 address to be used for " .
		      "communication", $ctl_addr6);
      } # ipv6
      
    }

    print "\n             X.509 Certificates           ";
    print "\n             ~~~~~~~~~~~~~~~~~~           \n";
    $href->{'ca_cert'} =
      get_string ("Enter the location of the Root Certificate",
		  $href->{prefix} . "/cert/CAcert.pem" );
    $href->{'ca_path'} =  $href->{'ca_cert'};
    $href->{'ca_path'} =~ s/\/[^\/]*$//g;

    $href->{'node_cert'} =
	get_string ("Specify the SSL certificate for this node",
		    "$href->{ca_path}/$href->{'hostname'}.cert.pem");

    $href->{'node_key'} =
	get_string ("Specify the SSL key for this node",
		    "$href->{ca_path}/$href->{'hostname'}.key.pem");

    print "\n                Miscellaneous                ";
    print "\n             ~~~~~~~~~~~~~~~~~~~           \n";

    $href->{'xbone_net'} = "xbone.overlay";
    $href->{'xbone_net'} =
	get_string ("Specify the prefix of the overlays.",
		    $href->{'xbone_net'}); 

    printf("\nPlease make sure that the prefix is consistent ".
	   "with the DNS configuration\n");

    $href->{'timeout'} = "20";
    $href->{'timeout'} =
	get_string ("\nSpecify a timeout for response from the node daemon",
		    $href->{'timeout'}); 

}



sub write_node ($$$)
  {
    my ($fh, $nodehref, $acldb) = @_;
    my (@keys, $key);

    print $fh "#************ X-Bone Configuration *************\n";
    print $fh "#  * This file has been automatically generated  *\n";
    print $fh "#  * Consult the documentation for more          *\n";
    print $fh "#  * information on how to set the variable in   *\n";
    print $fh "#  * file configuration file.                    *\n";
    print $fh "#*************************************************\n";
    print $fh "\n\n";
    my @variables = (		     
		     "hostname",
		     "ipproto", "ctl_addr", "ctl_addr6", 
		     "ca_path", "ca_cert","node_cert","node_key",
		     "xbone_net", "timeout",
		    );
    
    foreach $key (@variables){
      if (defined $nodehref->{$key}){
	print $fh "$key = $nodehref->{$key}\n";
      }
    }

  }




#####################################################################
#####################################################################
##
## MAIN ()
##
#####################################################################
#####################################################################

STDERR->autoflush(1);
STDOUT->autoflush(1);

my %nodedb = ();

my (@candidates, $result, $nodehref, $aclhref, @acldb);
my ($fh, $configuration, @aclhrefs);

#take the prefix from the command line
if ($#ARGV >= 0){ 
  $nodedb{prefix} = $ARGV[0];
} else {
  $nodedb{prefix} = "/usr/local/etc/xbone";
} 

print "\n###########################################";
print "\n       X-Bone GUI Version 3.1.1 Software   ";
print "\n            Configuration                  ";
print "\n###########################################";
print "\n\n";

# now read in all the variables.
$nodehref = \%nodedb;
fillin_nodedb ($nodehref);



###############################
# Determine where to write it.
###############################

while (1)
{
    $result = get_string ("\n\nFile for this configuration: ",
			  $nodehref->{prefix} . "/xbone-gui.conf");

    $fh = new FileHandle "> $result";
    if (!defined ($fh))
    {
	print "\n\aCould not open: $result.";
	next;
    }

    last;
}

#####################
# Write the XboneNode
# portion.
#####################

write_node ($fh, $nodehref, \@acldb);
print $fh "\n";

$fh->close;

print "\nFinished writing: $result\n\n";

if ($result ne "/usr/local/etc/xbone/xbone-gui.conf"){
  print
    "\n. Please make sure you edit \n".
    "        /usr/local/www/xbone/lib/XB_Params.pm         \n".
    "with the new location of the configuration file. Look \n".
    "for \$XB_Params::gui_conf. At this point there is no  \n".
    "command line option or other ways of supporting the   \n".
    "modified prefix\n"; 
}

exit (0);
